#_______________________
#PhotoReduc 
#version 1.1
#daniel MACOUIN 2007
#licence NOL
# : pas plus d'obligations pour vous que pour moi !
#______________________

# ce programme est crit en tcl/tk
# Il ne fait qu'une chose : 
# rduire les dimensions d'une image 
#  1/x des dimensions originelles
# 1/3 par dfaut.


package require Tk

 package require Img

#<variables_globales>
	global cheminPR
	set cheminPR [pwd]  
	
	global repertoire
	set repertoire ""
	
	global dossierReduc 
	set dossierReduc "" 
	
	global coefDivision
	set coefDivision 3
	
	global selecteur
	set selecteur R

#<interface>
wm title . "PhotoReduc 1.1"

global couleurBouton 
set couleurBouton blue

option add .Button.activeBackground azure

pack [frame .fa] -side left -expand true -fill both
pack [frame .fc -bg #808080] -side left -expand true -fill x
pack [frame .fb] -side left -expand true -fill both

pack [frame .fa.fr ] -side top -expand true -fill x
	pack [label .fa.fr.lmode -text "Mode Reduction" -relief groove ]  -side left -expand true 
	pack [radiobutton .fa.fr.r1 -text "Rapide" -variable selecteur -value "R" ] -side left -expand true 
	pack [radiobutton .fa.fr.r2 -text "Ulis" -variable selecteur -value "U"  ] -side left -expand true 
pack [label .fa.label1 -text "REPERTOIRE SOURCE" -font {helvetica 10 bold } -fg white  -bg black -relief sunken -bd 6] -side top -expand true -fill x
pack [text .fa.repertoire -relief groove -bd 5 -width 30 -cursor hand1 -bg ivory -yscrollcommand ".fa.y set " ]  -side right -after .fa.label1 -expand true -fill both
pack [scrollbar .fa.y -orient v -command { .fa.repertoire yview }] -side right -expand true -fill y 

pack [frame .fb.f ] -side top -expand true -fill x
	set imgUndo [ image create photo -file [file join [file dirname  [info script] ] undo.gif] ]
	set imgRedo [ image create photo -file [file join [file dirname [info script] ] redo.gif] ]
	pack [button .fb.f.bu  -image $imgUndo -command Defaire ] -side left 
	pack [button .fb.f.br  -image $imgRedo -command Refaire] -side left 
	
	pack [button .fb.f.bAbout -text "  propos... "  -relief raise  -command { AboutPhotoReduc } ] -side right  -expand true  
	pack [button .fb.f.bAide -text "   aide   "  -relief raise  -command { AfficheAide } ] -side right -expand true  
	
pack [label .fb.label1 -text "PHOTOS A REDUIRE" -font {helvetica 10 bold} -fg white -bg black -relief sunken -bd 6] -side top -expand true -fill x
pack [text .fb.repR -relief groove -bd 5 -width 40 -bg ivory   -fg  HotPink  -yscrollcommand ".fb.y set "  -undo 1] -side left  -after .fb.label1 -expand true -fill both
pack [scrollbar .fb.y -orient v -command { .fb.repR yview }] -side left -expand true -fill y

pack [message .fc.m1 -text "PHOTO REDUC 2007" -fg red -bg black -relief sunken -bd 9 -pady 30 -font {helvetica  16} ] -side top -expand true -fill x
pack [button .fc.b1 -text "Ouvrez un rpertoire contenant vos photos  rduire" \
	-command { AllerRepertoire }	]  -side top  -expand true -fill x
pack [label .fc.l1 -textvariable repertoire  -bg white -fg red ] -expand true -fill x -side top -after .fc.b1
pack [button .fc.b2 -text "Ouvrez un rpertoire pour sauver vos photos  rduites" -command { set dossierReduc [tk_chooseDirectory] } ]  -side top -expand true -fill x 
pack [label .fc.label2 -textvariable dossierReduc  -bg white -fg red ] -expand true -fill x -side top -after .fc.b2

pack [frame .fc.fChoixReduc  ] -expand true -fill x -side top -after .fc.label2 
pack [label .fc.fChoixReduc.labelCoef -text "Choisissez le coefficient de division" -bg black -fg white ] -side left -expand true -fill x  
pack [entry .fc.fChoixReduc.coefficient -textvariable coefDivision -width 3  -relief sunken ] -side right -expand true 

#<objectif>
pack [canvas .fc.canvas0  -height 130 -width 200 -bg #808080 ] -side top  -expand true
.fc.canvas0 create oval 50 10 160 120 -width 9 -fill ivory
.fc.canvas0 create oval 62 15 148 115 -width 9 -fill white
# .fc.canvas0 create oval 70 28 85 95 -width 0 -fill LightBlue  
.fc.canvas0 create oval 105 60 125 98 -width 0 -fill LightBlue   
.fc.canvas0 create oval 95 25 122 100 -width 0 -fill white
.fc.canvas0 create line 10 10 10 129 -width 3 -fill LightBlue 
.fc.canvas0 create line 190 10 190 129 -width 3 -fill LightBlue
.fc.canvas0 create line 10 129 190 129 -width 3 -fill LightBlue

pack [frame .fc.fbouton] -expand true -fill x -side bottom
pack [button .fc.fbouton.bVoir  -text "  voir   "   -fg black -relief raise  -font {-weight bold} -command {AfficheVisu } ] -side left 
#  pack [message .fc.fbouton.m2 -text "Cliquez sur chacun des  fichiers de la fentre de gauche que vous voulez reduire, ils s'inscriront dans la fentre de droite, puis envoyez! " -font { helvetica 8}] -side bottom -fill x -expand true
pack [button .fc.fbouton.bEnvoi -text "   envoi   "  -fg black -relief raise  -font {-weight bold} -command { ConfirmerMode } ] -side right   
 pack [label .fc.fbouton.voyant -text " "  -relief sunken  -font {-weight bold}] -side right -fill x -expand true

#<PROCEDURES>

proc AllerRepertoire { } {
	global repertoire
	set repertoire [tk_chooseDirectory  -title [::msgcat::mc  "PhotoReduc: cd rpertoire "]]
	.fa.repertoire delete 1.0 end
	set fichiers [glob -type f -directory $repertoire  * ]
	set j 0
	foreach i $fichiers {
	set k [file tail $i]
 	if { ([string compare [file extension $i ]  ".GIF" ] == 0) | ([string compare [file extension $i ]  ".gif" ] == 0) | ([string compare [file extension $i ]  ".jpg" ] == 0) | ([string compare [file extension $i ]  ".JPG" ] == 0) | ([string compare [file extension $i ]  ".JPEG" ] == 0) | ([string compare [file extension $i ]  ".jpeg" ] == 0)} {
	.fa.repertoire tag configure selectFichier$j
		.fa.repertoire insert 1.0 "$k \n" selectFichier$j 
		.fa.repertoire tag bind selectFichier$j <Enter> ".fa.repertoire tag configure 	selectFichier$j  -background red -foreground yellow " 
			.fa.repertoire tag bind selectFichier$j <Leave> " .fa.repertoire tag configure 	selectFichier$j -background ivory -foreground black "  
		.fa.repertoire tag bind selectFichier$j <1> " .fa.repertoire tag configure 	selectFichier$j -background green -foreground black ; InsererChemin {$i} ; 	"	
 		}
	incr j
	}
  }

proc InsererChemin {chemin} {
	.fb.repR insert end $chemin
	.fb.repR insert end "\n"
	
	.fb.repR see end 
}

proc AfficheVisu { } {

destroy .foto
toplevel .foto 
wm title .foto "PhotoRduc : Visualisation des images originelles"

pack [scrollbar .foto.x -command {.foto.visu xview} -orient h] -side bottom  -fill x 
pack [text .foto.visu -yscrollcommand ".foto.y set "  -xscrollcommand ".foto.x set " ]  -side left -expand true -fill both 
pack [scrollbar .foto.y -command {.foto.visu yview} ] -side right  -fill y 

bind .foto <3> {destroy .foto} 

set textePremier [ .fb.repR get 1.0 end]
set listeFichiers [split $textePremier \n]

	foreach fichier $listeFichiers {
	set filename "$fichier"
	
	set foto [image create photo  -file "$filename"	]
	
	.foto.visu insert end "\n$filename \n"
	.foto.visu image create insert -image $foto -name FOTO
	}
}

proc Defaire {} {
	catch {.fb.repR edit undo}

	  }
	  
	  
proc Refaire {} {
	catch {.fb.repR edit redo}
	  }
	
proc ConfirmerMode { } {
# permet d'arrter le lancement de la reduction en mode ulis
#  gourmand en temps de traitement
global selecteur

  if {$selecteur eq "U" } {
 	set reponseBox 	[tk_messageBox -message "ATENTION !
	Le mode ULIS est trs lent
	tes vous certain de vouloir continuer" \
	-icon warning -type okcancel ]
	
	switch -- $reponseBox {
	cancel { return }
	ok {	
		PhotoReduction 
	}
		}
  } else {
	PhotoReduction 
	}
}

proc PhotoReduction { } {
# la boucle ouvre les images correspondant aux fichiers lists dans la fentre de gauche
# et les sauvegarde dans le repertoire pralablement dtermin
#  en les rduidsant au tiers.
global repertoire
global dossierReduc
global coefDivision
global selecteur

set couleur [.fc.fbouton.voyant cget -background]
.fc.fbouton.voyant configure -bg red
after 50
update

destroy .fotoR
toplevel .fotoR
wm title .fotoR "PhotoReduc : Images reduites  "
pack [text .fotoR.visu -yscrollcommand ".fotoR.y set " ]  -side left -expand true -fill both 
pack [scrollbar .fotoR.y -command {.fotoR.visu yview} ] -side right  -fill y 
bind .fotoR <3> {destroy .fotoR } 


set textePremier [ .fb.repR get 1.0 end]
set listeFichiers [lrange [split $textePremier \n] 0 end-2]

   foreach fichier  $listeFichiers  {
	set fotoSource [image create photo  -file $fichier	]	
	set fotoReduite [image create photo ] 
	
	if { $selecteur eq "R" } {
	$fotoReduite copy $fotoSource -subsample $coefDivision
	.fotoR.visu image create insert -image $fotoReduite -name FOTOREDUITE
	
		if { [string compare [file tail $fichier ]  "" ] ==1} {
			if { ( [file extension $fichier ] eq ".gif" ) |  ( [file extension $fichier ] eq ".GIF" ) } {
				$fotoReduite write [file join $dossierReduc "PR_[file tail $fichier]" ] -format GIF  
			} else {
				$fotoReduite write [file join $dossierReduc "PR_[file tail $fichier]" ] -format JPEG
			}
		raise .fotoR.visu 
		}
	}  else {
			set coefUlis [expr 1.00 / $coefDivision ]
			catch {set fotoReduite [shrink $fotoSource $coefUlis] }
	
		.fotoR.visu image create insert -image $fotoReduite -name FOTOREDUITE
	
		if { [string compare [file tail $fichier ]  "" ] ==1} {
			if { ( [file extension $fichier ] eq ".gif" ) |  ( [file extension $fichier ] eq ".GIF" ) } {
				$fotoReduite write [file join $dossierReduc "U_[file tail $fichier]" ] -format GIF  
			} else {
		$fotoReduite write [file join $dossierReduc "U_[file tail $fichier]" ] -format JPEG
	}
	}
	raise .fotoR.visu 
	}
  }
			
	.fc.fbouton.voyant configure -bg green
update
after 1000
.fc.fbouton.voyant configure -bg $couleur
}


#_____________ALGORITMES ULIS ____________________

# shrinking without transparency :  methode ULIS
#_________________________________________________

proc shrink {Image coef} 	{
	  # check coef
	  if {$coef > 1.0} \
	  { error "bad coef \"$coef\": should not be greater than 1.0" }
	  if {abs($coef - 1.0) < 1.e-4} { return $Image }
	  # get the old image content
	  set Width [image width $Image]
	  set Height [image height $Image]
	  if {$Width * $Height == 0} { error "bad image" }
	  # create corresponding planes
	  for {set Y 0} {$Y < $Height} {incr Y} \
	  {
		set r:Row {}
		set g:Row {}
		set b:Row {}
		for {set X 0} {$X < $Width} {incr X} \
		{
		  foreach {r g b} [$Image get $X $Y] break
		  foreach c {r g b} { lappend $c:Row [set $c] }
		}
		foreach c {r g b} { lappend $c:Data [set $c:Row] }
	  }
	  # compute the new image content
	  set width [expr {round($Width * $coef)}]
	  set height [expr {round($Height * $coef)}]
	  set ey 0
	  set Y2 0
	  set cy2 $height
	  for {set y 0} {$y < $height} {incr y} \
	  {
		set r:row {}
		set g:row {}
		set b:row {}
		# Y1 is the top coordinate in the old image
		set Y1 $Y2
		set cy1 [expr {$height - $cy2}]
		incr ey $Height
		set Y2 [expr {$ey / $height}]
		set cy2 [expr {$ey % $height}]
		if {$Y1 == $Y2} { set cy1 $cy2 }
		set ex 0
		set X2 0
		set cx2 $width
		for {set x 0} {$x < $width} {incr x} \
		{
		  set X1 $X2
		  set cx1 [expr {$width - $cx2}]
		  incr ex $Width
		  set X2 [expr {$ex / $width}]
		  set cx2 [expr {$ex % $width}]
		  if {$X1 == $X2} { set cx1 $cx2 }
		  # compute pixel
		  foreach c {r g b} { set $c 0; set _$c 0 }
		  for {set Y $Y1} {$Y <= $Y2} {incr Y} \
		  {
			# compute y coef
			switch $Y \
			  $Y1	 { set cy $cy1 } \
			  $Y2	 { set cy $cy2 } \
			  default { set cy $height }
			if {$cy == 0} { continue }
			if {$cy > $Height} { set cy $Height }
			for {set X $X1} {$X <= $X2} {incr X} \
			{
			  # compute x coef
			  switch $X \
				$X1	 { set cx $cx1 } \
				$X2	 { set cx $cx2 } \
				default { set cx $width }
			  if {$cx == 0} { continue }
			  if {$cx > $Width} { set cx $Width }
			  # weight each initial pixel by cx & cy
			  set cxy [expr {$cx * $cy / double($Width) / $Height}]
			  foreach c {r g b} \
			  {
				set comp [lindex [set $c:Data] $Y $X]
				incr $c [expr {round($comp * $cxy)}]
				set _$c [expr {[set _$c] + $cxy}]
			  }
			}
		  }
		  set _ {}
		  foreach c {r g b} \
		  {
			set comp [set $c]
			if {$comp > 255} { set comp 255 }
			lappend $c:row $comp
			lappend _ [set _$c]
		  }
		}
		foreach c {r g b} { lappend $c:data [set $c:row] }
	  }
	  # merge the planes
	  for {set y 0} {$y < $height} {incr y} \
	  {
		set row {}
		for {set x 0} {$x < $width} {incr x} \
		{
		  foreach c {r g b} { set $c [lindex [set $c:data] $y $x] }
		  lappend row [format #%02x%02x%02x $r $g $b]
		}
		lappend data $row
	  }
	  # create the new image
	  set image [image create photo]
	  # fill the new image
	  catch {$image put $data }
	  # return the new image
	  return $image
	}
# 	  # return the new image
# 	  return $image
# 	}
	
proc AboutPhotoReduc { } {
destroy .about
	toplevel .about  -bg pink 
	wm title .about "PhotoReduc info"
	wm geometry .about 150x250+250+250
	pack [text .about.t -bg #e0b87c   -wrap word ] -expand true -fill both
	.about.t insert end " 
PHOTOREDUC 
version 1.1
	
Daniel MACOUIN .2007.
Licence NOL :
 pas d'obligation,
 ni pour vous,
 ni pour moi.
	
Le mode d'interpolation linaire 
a t mis au point par ULIS.
Plus d'informations sur la page:
http://wfr.tcl.tk/409"
	
	wm overrideredirect .about 1
	
	bind .about <Enter> {destroy .about}	
}


proc AfficheAide {} {
toplevel .aide
wm title .aide "AIDE de PhotoReduc "

pack [text .aide.texte -width 35 -bg lavender -relief sunken -bd 5 -yscrollcommand ".aide.y  set"  -wrap word -font {helvetica 10} ] -side left -expand true -fill both 
pack [scrollbar .aide.y -orient v -command {.aide.texte yview } ] -side left -before .aide.texte  -fill y -expand true
bind .aide <3> {destroy .aide }
.aide.texte insert end "

 Cette fentre se ferme par un clic! droit 
____________________

  AIDE DE PHOTOREDUC 
____________________


PhotoReduc diminue par un nombre entier (trois par dfaut) la taille des images au format JPEG ou au format GIF.
	ATTENTION : ce programme crit en TclTk ncessite le package Img pour reconnaitre le format jpeg. Si ce package est mal install sur votre ordinateur, PhotoReduc ne pourra traiter que les images GIF.


PhotoReduc permet de prparer une liste d'images  rduire  partir d'un ou plusieurs rpertoires et d'effectuer en rafale la rduction de dimensions.

* On ouvre un dossier o se trouvent des images, et la liste des fichiers JPEG s'inscrit ligne par ligne dans la fentre de gauche.

* En cliquant sur le nom d'un fichier, son chemin complet s'inscrit dans la fentre de droite.
* On peut renouveler l'opration en ouvrant d'autres dossiers. 

* On peut visualiser  tout moment les images choisies en cliquant sur ''VOIR''.

* On peut supprimer une image de la liste comme on le ferait dans un traitement de texte ordinaire.
	
	>> On choisit le taux de rduction dsir dans la petite lucarne prvue  cet effet. Par dfaut l'image sera divise par 3. 
	>> En haut  gauche on peut choisir le mode rapide ou le mode Ulis (du nom de l'inventeur de l'algoritme.
		> le mode rapide prend, par defaut, un pixel sur trois de l'image originelle, un pixel sur ''Coefficient'' d'une manire gnrale.
		> le mode Ulis utilise un systme plus subtil o la couleur d'un pixel de l'image rduite est recalcule en fonction de ceux qui l'entourent. L'image est beaucoup plus belle. En revanche les calculs peuvent prendre beaucoup de temps sur de grosses images.	
	>> Quand la liste est tablie, en cliquant sur ''ENVOI'' , on sauvegarde les images rduites dans le fichier pralablement choisi pour les accueillir. 
		
		 Leur nom est alors PR_nomImageOrigine pour le mode rapide.
		 Leur nom est alors U_nomImageOrigine pour le mode Ulis.

	Les nouvelles images, rduites, s'affichent dans une fentre ad hoc.

____________________
"
#<tag>
.aide.texte tag configure clic -font  {helvetica 10 italic }  -foreground white -background DarkGreen 
.aide.texte tag add clic 3.0 {3.0 lineend} 

.aide.texte tag configure titre -font  {helvetica 14 bold}  -foreground blue
.aide.texte tag add titre 6.0 {6.0 lineend} 

set logo [image create photo  -file [file join [pwd] photoreduc.gif ] ]
.aide.texte image create 6.0 -image $logo -name PhotoReduc
}





